signals.c File Reference

Handling signals to abort operation. More...

`#include "private.h"`

## Functions

static void | signal_handler (int sig)
void | signals_init (void)
void | signals_block (void)
void | signals_unblock (void)
| Unblock the signals blocked by signals_block(). More...
void | signals_exit (void)

## Variables

volatile sig_atomic_t | user_abort = false
static volatile sig_atomic_t | exit_signal = 0
static sigset_t | hooked_signals
static bool | signals_are_initialized = false
static size_t | signals_block_count = 0
| signals_block() and signals_unblock() can be called recursively. More...

## Detailed Description

Handling signals to abort operation.

## Function Documentation

## signals_init()

void signals_init | ( | void |  | ) |

Initialize the signal handler, which will set user_abort to true when user e.g. presses C-c.

References hooked_signals.

## signals_block()

void signals_block | ( | void |  | ) |

Block the signals which don't have SA_RESTART and which would just set user_abort to true. This is handy when we don't want to handle EINTR and don't want SA_RESTART either.

References signals_are_initialized, and signals_block_count.

Referenced by io_open_dest(), io_open_src(), and message_progress_update().

## signals_unblock()

void signals_unblock | ( | void |  | ) |

Unblock the signals blocked by signals_block().

References signals_are_initialized.

Referenced by io_open_src().

## signals_exit()

void signals_exit | ( | void |  | ) |

If user has sent us a signal earlier to terminate the process, re-raise that signal to actually terminate the process.

References exit_signal, and set_exit_status().

## Variable Documentation

## user_abort

volatile sig_atomic_t user_abort = false

If this is true, we will clean up the possibly incomplete output file, return to main() as soon as practical. That is, the code needs to poll this variable in various places.

Referenced by coder_passthru(), and io_wait().

## exit_signal

volatile sig_atomic_t exit_signal = 0

static

If we were interrupted by a signal, we store the signal number so that we can raise that signal to kill the program when all cleanups have been done.

Referenced by signals_exit().

## hooked_signals

sigset_t hooked_signals

static

Mask of signals for which we have established a signal handler to set user_abort to true.

Referenced by signals_init().

## signals_are_initialized

bool signals_are_initialized = false

static

True once signals_init() has finished. This is used to skip blocking signals (with uninitialized hooked_signals) if signals_block() and signals_unblock() are called before signals_init() has been called.

Referenced by signals_block(), and signals_unblock().

## signals_block_count

size_t signals_block_count = 0

static

signals_block() and signals_unblock() can be called recursively.

Referenced by signals_block().